Debian Bug report logs - #437507
dpkg-cross: broken CC_FOR_BUILD handling in diverted dpkg-buildpackage

version graph

Package: dpkg-cross; Maintainer for dpkg-cross is Debian Embedded Group <debian-embedded@lists.debian.org>; Source for dpkg-cross is src:dpkg-cross.

Reported by: Neil Williams <codehelp@debian.org>

Date: Mon, 21 May 2007 17:57:02 UTC

Severity: normal

Tags: confirmed, fixed-in-experimental

Fixed in version dpkg-cross/1.99+2.0.0pre1

Done: Neil Williams <codehelp@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#425445; Package libx11. Full text and rfc822 format available.

Acknowledgement sent to Neil Williams <codehelp@debian.org>:
New Bug report received and forwarded. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Neil Williams <codehelp@debian.org>
To: submit@bugs.debian.org
Subject: libx11-6: fails to cross-build. tries to run cross-built makekeys utility
Date: Mon, 21 May 2007 16:38:18 +0100
[Message part 1 (text/plain, inline)]
Package: libx11
Severity: normal

When cross-building (Emdebian), libx11 compiles src/util/makekeys.c
using the --host compiler then tries to execute it on the --build
system, causing a failure:

arm-linux-gnu-gcc  -Wall -g -O2 -DLIBXCURSOR=\"libXcursor.so.1\"   -o makekeys  makekeys-makekeys.o  -ldl 
make[3]: Leaving directory `/opt/emdebian/trunk/l/libx11/trunk/libx11-1.0.3/obj-x86_64-linux-gnu/src/util'
../src/util/makekeys < /usr/arm-linux-gnu/include/X11/keysymdef.h > ks_tables_h
/bin/sh: ../src/util/makekeys: cannot execute binary file

Build information:
http://buildd.emdebian.org/svn/browser/current/target/trunk/l/libx11/branches/fail1

Build log:
http://buildd.emdebian.org/svn/browser/current/target/trunk/l/libx11/branches/fail1/libx11_2%3A1.0.3-7em1_arm.build


--- System information. ---
Architecture: amd64
Kernel:       Linux 2.6.18-4-amd64

Debian Release: lenny/sid
  500 unstable        www.linux.codehelp.co.uk 
  500 unstable        www.emdebian.org 
  500 unstable        ftp.uk.debian.org 


-- 


Neil Williams
=============
http://www.data-freedom.org/
http://www.nosoftwarepatents.com/
http://www.linux.codehelp.co.uk/

[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#425445; Package libx11. Full text and rfc822 format available.

Acknowledgement sent to Julien Cristau <jcristau@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #10 received at 425445@bugs.debian.org (full text, mbox):

From: Julien Cristau <jcristau@debian.org>
To: Neil Williams <codehelp@debian.org>, 425445@bugs.debian.org
Subject: Re: Bug#425445: libx11-6: fails to cross-build. tries to run cross-built makekeys utility
Date: Sun, 12 Aug 2007 16:59:25 +0200
[Message part 1 (text/plain, inline)]
On Mon, May 21, 2007 at 16:38:18 +0100, Neil Williams wrote:

> arm-linux-gnu-gcc  -Wall -g -O2 -DLIBXCURSOR=\"libXcursor.so.1\"   -o makekeys  makekeys-makekeys.o  -ldl 
> make[3]: Leaving directory `/opt/emdebian/trunk/l/libx11/trunk/libx11-1.0.3/obj-x86_64-linux-gnu/src/util'
> ../src/util/makekeys < /usr/arm-linux-gnu/include/X11/keysymdef.h > ks_tables_h
> /bin/sh: ../src/util/makekeys: cannot execute binary file
> 
Hi Neil,

can you test the following patch?

Thanks,
Julien

From f438f69ee4246fb27053426a285d1d6ffa7fa60e Mon Sep 17 00:00:00 2001
From: Julien Cristau <jcristau@debian.org>
Date: Sun, 12 Aug 2007 16:54:48 +0200
Subject: [PATCH] Build makekeys with CC_FOR_BUILD to fix cross-compiling

makekeys is run during the build process, so needs to be built
with a native compiler.
---
 configure.ac         |    6 ++++++
 src/util/Makefile.am |    3 +--
 2 files changed, 7 insertions(+), 2 deletions(-)

diff --git a/configure.ac b/configure.ac
index f49b9ed..3125dc4 100644
--- a/configure.ac
+++ b/configure.ac
@@ -18,6 +18,12 @@ AC_CONFIG_HEADER([include/X11/XlibConf.h])
 AC_PROG_LIBTOOL
 AC_PROG_CC
 
+if test x"$cross_compiling" = xyes; then
+	AC_CHECK_PROGS(CC_FOR_BUILD, gcc cc)
+else
+	CC_FOR_BUILD="$CC"
+fi
+
 XORG_PROG_RAWCPP
 
 # Build with XCB support?
diff --git a/src/util/Makefile.am b/src/util/Makefile.am
index 3ff421d..c9e81c0 100644
--- a/src/util/Makefile.am
+++ b/src/util/Makefile.am
@@ -4,8 +4,7 @@ noinst_PROGRAMS=makekeys
 
 makekeys_CFLAGS=$(X11_CFLAGS)
 
-#override CC = gcc
-LINK = $(CC) $(AM_CFLAGS) $(CFLAGS) $(AM_LDFLAGS) $(LDFLAGS) -o $@
+CC = @CC_FOR_BUILD@
 
 EXTRA_DIST = mkks.sh
 
-- 
1.5.2.4

[signature.asc (application/pgp-signature, inline)]

Tags added: upstream, confirmed Request was from Julien Cristau <jcristau@debian.org> to control@bugs.debian.org. (Sun, 12 Aug 2007 15:03:04 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#425445; Package libx11. Full text and rfc822 format available.

Acknowledgement sent to Neil Williams <codehelp@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #17 received at 425445@bugs.debian.org (full text, mbox):

From: Neil Williams <codehelp@debian.org>
To: Julien Cristau <jcristau@debian.org>
Cc: 425445@bugs.debian.org
Subject: Re: Bug#425445: libx11-6: fails to cross-build. tries to run cross-built makekeys utility
Date: Sun, 12 Aug 2007 21:45:36 +0100
[Message part 1 (text/plain, inline)]
On Sun, 12 Aug 2007 16:59:25 +0200
Julien Cristau <jcristau@debian.org> wrote:

> Hi Neil,
> 
> can you test the following patch?
> 
>  configure.ac         |    6 ++++++
>  src/util/Makefile.am |    3 +--
>  2 files changed, 7 insertions(+), 2 deletions(-)
> 
> diff --git a/configure.ac b/configure.ac
> index f49b9ed..3125dc4 100644
> --- a/configure.ac
> +++ b/configure.ac
> @@ -18,6 +18,12 @@ AC_CONFIG_HEADER([include/X11/XlibConf.h])
>  AC_PROG_LIBTOOL
>  AC_PROG_CC
>  
> +if test x"$cross_compiling" = xyes; then
> +	AC_CHECK_PROGS(CC_FOR_BUILD, gcc cc)
> +else
> +	CC_FOR_BUILD="$CC"
> +fi
> +

CC_FOR_BUILD needs to be substituted so I added:
AC_SUBST(CC_FOR_BUILD)

>  XORG_PROG_RAWCPP
>  
>  # Build with XCB support?
> diff --git a/src/util/Makefile.am b/src/util/Makefile.am
> index 3ff421d..c9e81c0 100644
> --- a/src/util/Makefile.am
> +++ b/src/util/Makefile.am
> @@ -4,8 +4,7 @@ noinst_PROGRAMS=makekeys
>  
>  makekeys_CFLAGS=$(X11_CFLAGS)
>  
> -#override CC = gcc
> -LINK = $(CC) $(AM_CFLAGS) $(CFLAGS) $(AM_LDFLAGS) $(LDFLAGS) -o $@
> +CC = @CC_FOR_BUILD@

I could not get that to work.

A working patch, based on the above, is attached, using the 'override'
command to 'make'.

If this patch is applied within Debian, autoconf needs to be added to
debian/rules build-stamp target:

 build-stamp:
        dh_testdir
-
+       autoconf
and the Build-Depends.

That can be skipped if the patch is applied upstream.

Emdebian patches:
http://buildd.emdebian.org/svn/browser/current/target/trunk/l/libx11/trunk/
http://buildd.emdebian.org/svn/browser/current/target/trunk/l/libx11/trunk/debian-patch-023_emdebian.diff?rev=1460&format=txt

Build log:
http://buildd.emdebian.org/svn/browser/current/target/trunk/l/libx11/trunk/libx11_2%3A1.0.3-7em1_arm.build?format=raw

-- 


Neil Williams
=============
http://www.data-freedom.org/
http://www.nosoftwarepatents.com/
http://www.linux.codehelp.co.uk/

[debian-patch-023_emdebian.diff (text/x-diff, attachment)]
[Message part 3 (application/pgp-signature, inline)]

Tags added: patch Request was from Neil Williams <codehelp@debian.org> to control@bugs.debian.org. (Sun, 12 Aug 2007 20:57:08 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#425445; Package libx11. Full text and rfc822 format available.

Acknowledgement sent to Julien Cristau <jcristau@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #24 received at 425445@bugs.debian.org (full text, mbox):

From: Julien Cristau <jcristau@debian.org>
To: Neil Williams <codehelp@debian.org>
Cc: 425445@bugs.debian.org
Subject: Re: Bug#425445: libx11-6: fails to cross-build. tries to run cross-built makekeys utility
Date: Sun, 12 Aug 2007 22:58:48 +0200
[Message part 1 (text/plain, inline)]
On Sun, Aug 12, 2007 at 21:45:36 +0100, Neil Williams wrote:

> On Sun, 12 Aug 2007 16:59:25 +0200
> Julien Cristau <jcristau@debian.org> wrote:
> 
> > diff --git a/configure.ac b/configure.ac
> > index f49b9ed..3125dc4 100644
> > --- a/configure.ac
> > +++ b/configure.ac
> > @@ -18,6 +18,12 @@ AC_CONFIG_HEADER([include/X11/XlibConf.h])
> >  AC_PROG_LIBTOOL
> >  AC_PROG_CC
> >  
> > +if test x"$cross_compiling" = xyes; then
> > +	AC_CHECK_PROGS(CC_FOR_BUILD, gcc cc)
> > +else
> > +	CC_FOR_BUILD="$CC"
> > +fi
> > +
> 
> CC_FOR_BUILD needs to be substituted so I added:
> AC_SUBST(CC_FOR_BUILD)
> 
hmm, i wonder why it worked for me...

> >  XORG_PROG_RAWCPP
> >  
> >  # Build with XCB support?
> > diff --git a/src/util/Makefile.am b/src/util/Makefile.am
> > index 3ff421d..c9e81c0 100644
> > --- a/src/util/Makefile.am
> > +++ b/src/util/Makefile.am
> > @@ -4,8 +4,7 @@ noinst_PROGRAMS=makekeys
> >  
> >  makekeys_CFLAGS=$(X11_CFLAGS)
> >  
> > -#override CC = gcc
> > -LINK = $(CC) $(AM_CFLAGS) $(CFLAGS) $(AM_LDFLAGS) $(LDFLAGS) -o $@
> > +CC = @CC_FOR_BUILD@
> 
> I could not get that to work.
> 
> A working patch, based on the above, is attached, using the 'override'
> command to 'make'.
> 
The override command is gnu make specific, so that's not a good
solution.

Cheers,
Julien
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#425445; Package libx11. Full text and rfc822 format available.

Acknowledgement sent to Neil Williams <codehelp@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #29 received at 425445@bugs.debian.org (full text, mbox):

From: Neil Williams <codehelp@debian.org>
To: Julien Cristau <jcristau@debian.org>
Cc: 425445@bugs.debian.org
Subject: Re: Bug#425445: libx11-6: fails to cross-build. tries to run cross-built makekeys utility
Date: Sun, 12 Aug 2007 22:15:15 +0100
[Message part 1 (text/plain, inline)]
On Sun, 12 Aug 2007 22:58:48 +0200
Julien Cristau <jcristau@debian.org> wrote:

> > > -#override CC = gcc
> > > -LINK = $(CC) $(AM_CFLAGS) $(CFLAGS) $(AM_LDFLAGS) $(LDFLAGS) -o $@
> > > +CC = @CC_FOR_BUILD@
> > 
> > I could not get that to work.
> > 
> > A working patch, based on the above, is attached, using the 'override'
> > command to 'make'.
> > 
> The override command is gnu make specific, so that's not a good
> solution.

Which is preferable:
1. Require GNU make to cross-build, or
2. Hardcode gcc into a series of *manual* make rules in src/utils/
3. find a different way to generate the makekeys output
?

I could envisage a method in this part of debian/rules:

ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
	confflags += --build=$(DEB_HOST_GNU_TYPE)
else
	confflags += --build=$(DEB_BUILD_GNU_TYPE) --host=$(DEB_HOST_GNU_TYPE)
	# add emdebian patch to quilt here
endif

Presumably, quilt can be used to add 023_gnu_cross.diff (renamed to
indicate cross-building only and reliance on GNU make?) to the patch
series only if cross-building? (I don't use quilt much.)

This way, the override command would only be used if cross-building the
Debian package so we can be fairly sure that GNU make is being used.
Certainly, Emdebian will be using GNU make.

OK, it means the patch can't go upstream but if debian/rules can
arrange to add the patch (via quilt) only when cross-building, I'd be
happy with that.

-- 


Neil Williams
=============
http://www.data-freedom.org/
http://www.nosoftwarepatents.com/
http://www.linux.codehelp.co.uk/

[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#425445; Package libx11. Full text and rfc822 format available.

Acknowledgement sent to Julien Cristau <jcristau@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #34 received at 425445@bugs.debian.org (full text, mbox):

From: Julien Cristau <jcristau@debian.org>
To: Neil Williams <codehelp@debian.org>
Cc: 425445@bugs.debian.org
Subject: Re: Bug#425445: libx11-6: fails to cross-build. tries to run cross-built makekeys utility
Date: Sun, 12 Aug 2007 23:29:16 +0200
[Message part 1 (text/plain, inline)]
On Sun, Aug 12, 2007 at 22:15:15 +0100, Neil Williams wrote:

> On Sun, 12 Aug 2007 22:58:48 +0200
> Julien Cristau <jcristau@debian.org> wrote:
> > The override command is gnu make specific, so that's not a good
> > solution.
> 
> Which is preferable:
> 1. Require GNU make to cross-build, or
> 2. Hardcode gcc into a series of *manual* make rules in src/utils/
> 3. find a different way to generate the makekeys output
> ?
> 
Whatever can be accepted upstream.  Which means that 1 is not an option.

> I could envisage a method in this part of debian/rules:
> 
> ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
> 	confflags += --build=$(DEB_HOST_GNU_TYPE)
> else
> 	confflags += --build=$(DEB_BUILD_GNU_TYPE) --host=$(DEB_HOST_GNU_TYPE)
> 	# add emdebian patch to quilt here
> endif
> 
> Presumably, quilt can be used to add 023_gnu_cross.diff (renamed to
> indicate cross-building only and reliance on GNU make?) to the patch
> series only if cross-building? (I don't use quilt much.)
> 
> This way, the override command would only be used if cross-building the
> Debian package so we can be fairly sure that GNU make is being used.
> Certainly, Emdebian will be using GNU make.
> 
> OK, it means the patch can't go upstream but if debian/rules can
> arrange to add the patch (via quilt) only when cross-building, I'd be
> happy with that.
> 
I'm not really interested in a patch which can't go upstream.

Does the attached debdiff fix your build (on top of experimental's
2:1.1.3-1)?

Thanks,
Julien
[libx11_cross_build.debdiff (text/plain, attachment)]
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#425445; Package libx11. Full text and rfc822 format available.

Acknowledgement sent to Neil Williams <codehelp@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #39 received at 425445@bugs.debian.org (full text, mbox):

From: Neil Williams <codehelp@debian.org>
To: Julien Cristau <jcristau@debian.org>
Cc: 425445@bugs.debian.org
Subject: Re: Bug#425445: libx11-6: fails to cross-build. tries to run cross-built makekeys utility
Date: Sun, 12 Aug 2007 23:21:05 +0100
[Message part 1 (text/plain, inline)]
On Sun, 12 Aug 2007 23:29:16 +0200
Julien Cristau <jcristau@debian.org> wrote:

> > Which is preferable:
> > 1. Require GNU make to cross-build, or
> > 2. Hardcode gcc into a series of *manual* make rules in src/utils/
> > 3. find a different way to generate the makekeys output
> > ?
> > 
> Whatever can be accepted upstream.  Which means that 1 is not an option.

What is the problem with keeping a patch in Debian that is not intended
for upstream?

> > OK, it means the patch can't go upstream but if debian/rules can
> > arrange to add the patch (via quilt) only when cross-building, I'd be
> > happy with that.
> > 
> I'm not really interested in a patch which can't go upstream.

Then it looks like I'll have to maintain an Emdebian patch instead.

There has to be a sane way to cross-build the Debian package - the
upstream code cross-builds for others. (See OpenEmbedded.) That is why
I would be happy for this to be a Debian-only solution - there appears
to be something wrong with the Debian build that can work with the raw
upstream code. (i.e. I disagree with the 'upstream' tag on this bug.)

True, if a solution is found that also works upstream then that would
benefit everyone but that is not sufficient cause to refuse to fix the
Debian package, IMHO.

> Does the attached debdiff fix your build (on top of experimental's
> 2:1.1.3-1)?

NO.

(Gee, another 6 dependencies - that's just what I needed for an
embedded X11 system.) :-(

The package in experimental does not even get passed configure because
the new dependencies are also borked.

checking for X11... configure: error: Package requirements (xextproto xtrans xcb-xlib >= 0.9.92) were not met:

Package pthread-stubs was not found in the pkg-config search path.
Perhaps you should add the directory containing `pthread-stubs.pc'
to the PKG_CONFIG_PATH environment variable
Package 'pthread-stubs', required by 'XCB', not found

Consider adjusting the PKG_CONFIG_PATH environment variable if you
installed software in a non-standard prefix.

Alternatively, you may set the environment variables X11_CFLAGS
and X11_LIBS to avoid the need to call pkg-config.
See the pkg-config man page for more details.

(apt-cross reports the installation status of foo-arm-cross in each case)
$ apt-cross -v -i libxcb1-dev
checking libxcb1-dev dependencies . . . 
libxcb1-dev depends on libxcb1, installed (1.0-3) : OK
libxcb1-dev depends on libpthread-stubs0-dev, installed (0.1-2) : OK
libxcb1-dev depends on libxau-dev, installed (1) : OK
libxcb1-dev depends on libxdmcp-dev, installed (1) : OK
One package to install.
Installing: libxcb1-dev
libxcb1-dev-arm-cross (1.0-3) is already installed.

$ dpkg -l 'libpthread*' | grep arm
ii  libpthread-stubs0-arm-cross     0.1-2          pthread stubs not provided by native libc (f
ii  libpthread-stubs0-dev-arm-cross 0.1-2          pthread stubs not provided by native libc, d

$ dpkg -L libpthread-stubs0-dev
/.
/usr
/usr/share
/usr/share/doc
/usr/share/doc/libpthread-stubs0-dev
/usr/share/doc/libpthread-stubs0-dev/README
/usr/share/doc/libpthread-stubs0-dev/copyright
/usr/share/doc/libpthread-stubs0-dev/changelog.Debian.gz
/usr/share/pkgconfig
/usr/share/pkgconfig/pthread-stubs.pc

That should be /usr/lib/pkgconfig/pthread-stubs.pc

Forcing the file into the correct location at least allows the build to
continue to the inevitable makekeys failure:

make[3]: Entering directory `/opt/emdebian/trunk/l/libx11/branches/upstream/libx11-1.1.3/obj-x86_64-linux-gnu/src/util'
arm-linux-gnu-gcc -DHAVE_CONFIG_H -I. -I../../src -I../../include/X11 -I../../../src/util    -Wall -Wpointer-arith -Wstrict-prototypes       -Wmissing-prototypes -Wmissing-declarations     -Wnested-externs -fno-strict-aliasing -D_BSD_SOURCE -DHAS_FCHOWN -DHAS_STICKY_DIR_BIT -I/usr/arm-linux-gnu/include    -I/usr/arm-linux-gnu/include   -I/usr/arm-linux-gnu/include   -Wall -g -O2 -MT makekeys-makekeys.o -MD -MP -MF .deps/makekeys-makekeys.Tpo -c -o makekeys-makekeys.o `test -f 'makekeys.c' || echo '../../../src/util/'`makekeys.c
mv -f .deps/makekeys-makekeys.Tpo .deps/makekeys-makekeys.Po
/bin/sh ../../libtool --tag=CC   --mode=link arm-linux-gnu-gcc -Wall -Wpointer-arith -Wstrict-prototypes        -Wmissing-prototypes -Wmissing-declarations  -Wnested-externs -fno-strict-aliasing -D_BSD_SOURCE -DHAS_FCHOWN -DHAS_STICKY_DIR_BIT -I/usr/arm-linux-gnu/include    -I/usr/arm-linux-gnu/include   -I/usr/arm-linux-gnu/include   -Wall -g -O2   -o makekeys makekeys-makekeys.o  -ldl 
mkdir .libs
arm-linux-gnu-gcc -Wall -Wpointer-arith -Wstrict-prototypes -Wmissing-prototypes -Wmissing-declarations -Wnested-externs -fno-strict-aliasing -D_BSD_SOURCE -DHAS_FCHOWN -DHAS_STICKY_DIR_BIT -I/usr/arm-linux-gnu/include -I/usr/arm-linux-gnu/include -I/usr/arm-linux-gnu/include -Wall -g -O2 -o makekeys makekeys-makekeys.o  -ldl  
make[3]: Leaving directory `/opt/emdebian/trunk/l/libx11/branches/upstream/libx11-1.1.3/obj-x86_64-linux-gnu/src/util'
../src/util/makekeys < /usr/arm-linux-gnu/include/X11/keysymdef.h > ks_tables_h
/bin/sh: ../src/util/makekeys: cannot execute binary file
make[2]: *** [ks_tables.h] Error 126
make[2]: Leaving directory `/opt/emdebian/trunk/l/libx11/branches/upstream/libx11-1.1.3/obj-x86_64-linux-gnu/src'
make[1]: *** [all-recursive] Error 1
make[1]: Leaving directory `/opt/emdebian/trunk/l/libx11/branches/upstream/libx11-1.1.3/obj-x86_64-linux-gnu'
make: *** [build-stamp] Error 2
make: Leaving directory `/opt/emdebian/trunk/l/libx11/branches/upstream/libx11-1.1.3'

I'm not sure why you thought this would work because the debdiff
contained no changes that would have resulted in the src/utils/Makefile
using gcc in place of arm-linux-gnu-gcc because the critical variables
are defined BEFORE CC_FOR_BUILD is even specified. THAT is why I had to
use override.

What are you using to build at your end? What is it that makes you
think that this can be solved without 'override' ?

-- 


Neil Williams
=============
http://www.data-freedom.org/
http://www.nosoftwarepatents.com/
http://www.linux.codehelp.co.uk/

[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#425445; Package libx11. Full text and rfc822 format available.

Acknowledgement sent to Julien Cristau <jcristau@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #44 received at 425445@bugs.debian.org (full text, mbox):

From: Julien Cristau <jcristau@debian.org>
To: Neil Williams <codehelp@debian.org>, 425445@bugs.debian.org
Subject: Re: Bug#425445: libx11-6: fails to cross-build. tries to run cross-built makekeys utility
Date: Mon, 13 Aug 2007 00:57:04 +0200
On Sun, Aug 12, 2007 at 23:21:05 +0100, Neil Williams wrote:

> I'm not sure why you thought this would work because the debdiff
> contained no changes that would have resulted in the src/utils/Makefile
> using gcc in place of arm-linux-gnu-gcc because the critical variables
> are defined BEFORE CC_FOR_BUILD is even specified. THAT is why I had to
> use override.
> 
What variables?  src/utils/Makefile.in has 'CC = @CC_FOR_BUILD@', which
becomes 'CC = gcc' in src/utils/Makefile.
I don't believe the only way to build makekeys with a native compiler is
using a gnu makeism.

> What are you using to build at your end? What is it that makes you
> think that this can be solved without 'override' ?
> 
I installed the libc6-dev-arm-cross and gcc-4.1-arm-linux-gnu from the
emdebian repo, symlinked /usr/include/X11 from
/usr/arm-linux-gnu/include/ (hopefully any differences here don't
matter), and ran dpkg-buildpackage -rfakeroot -B -aarm.
Of course the package doesn't build because I don't have some of the
necessary stuff, but it gets further than the makekeys stuff.

The log has:
/bin/sh ../../../libtool --tag=CC   --mode=link arm-linux-gnu-gcc -I../../../../include -I../../../../include/X11 -I../../../include -I../../../include/X11 -I../../../../src/xcms -I../../../../src/xkb -I../../../../src/xlibi18n -I../../../../src -Wall -Wpointer-arith -Wstrict-prototypes         -Wmissing-prototypes -Wmissing-declarations     -Wnested-externs -fno-strict-aliasing -D_BSD_SOURCE -DHAS_FCHOWN -DHAS_STICKY_DIR_BIT          -D_BSD_SOURCE -DMALLOC_0_RETURNS_NULL -Wall -g -O2   -o libxomGeneric.la  omDefault.lo omGeneric.lo omImText.lo omText.lo omTextEsc.lo omTextExt.lo omTextPer.lo omXChar.lo  -ldl 
arm-linux-gnu-ar cru .libs/libxomGeneric.a .libs/omDefault.o .libs/omGeneric.o .libs/omImText.o .libs/omText.o .libs/omTextEsc.o .libs/omTextExt.o .libs/omTextPer.o .libs/omXChar.o
arm-linux-gnu-ranlib .libs/libxomGeneric.a
creating libxomGeneric.la
(cd .libs && rm -f libxomGeneric.la && ln -s ../libxomGeneric.la libxomGeneric.la)
make[4]: Leaving directory `/home/julien/src/xsf/git/lib/libx11/obj-i486-linux-gnu/modules/om/generic'
make[4]: Entering directory `/home/julien/src/xsf/git/lib/libx11/obj-i486-linux-gnu/modules/om'
make[4]: Nothing to be done for `all-am'.
make[4]: Leaving directory `/home/julien/src/xsf/git/lib/libx11/obj-i486-linux-gnu/modules/om'
make[3]: Leaving directory `/home/julien/src/xsf/git/lib/libx11/obj-i486-linux-gnu/modules/om'
make[3]: Entering directory `/home/julien/src/xsf/git/lib/libx11/obj-i486-linux-gnu/modules'
make[3]: Nothing to be done for `all-am'.
make[3]: Leaving directory `/home/julien/src/xsf/git/lib/libx11/obj-i486-linux-gnu/modules'
make[2]: Leaving directory `/home/julien/src/xsf/git/lib/libx11/obj-i486-linux-gnu/modules'
Making all in src
make[2]: Entering directory `/home/julien/src/xsf/git/lib/libx11/obj-i486-linux-gnu/src'
cd util && /usr/bin/make
make[3]: Entering directory `/home/julien/src/xsf/git/lib/libx11/obj-i486-linux-gnu/src/util'
gcc -DHAVE_CONFIG_H -I. -I../../src -I../../include/X11 -I../../../src/util    -Wall -Wpointer-arith -Wstrict-prototypes        -Wmissing-prototypes -Wmissing-declarations     -Wnested-externs -fno-strict-aliasing -D_BSD_SOURCE -DHAS_FCHOWN -DHAS_STICKY_DIR_BIT        -Wall -g -O2 -MT makekeys-makekeys.o -MD -MP -MF .deps/makekeys-makekeys.Tpo -c -o makekeys-makekeys.o `test -f 'makekeys.c' || echo '../../../src/util/'`makekeys.c
mv -f .deps/makekeys-makekeys.Tpo .deps/makekeys-makekeys.Po
/bin/sh ../../libtool --tag=CC   --mode=link gcc -Wall -Wpointer-arith -Wstrict-prototypes      -Wmissing-prototypes -Wmissing-declarations     -Wnested-externs -fno-strict-aliasing -D_BSD_SOURCE -DHAS_FCHOWN -DHAS_STICKY_DIR_BIT        -Wall -g -O2   -o makekeys makekeys-makekeys.o  -ldl 
mkdir .libs
gcc -Wall -Wpointer-arith -Wstrict-prototypes -Wmissing-prototypes -Wmissing-declarations -Wnested-externs -fno-strict-aliasing -D_BSD_SOURCE -DHAS_FCHOWN -DHAS_STICKY_DIR_BIT -Wall -g -O2 -o makekeys makekeys-makekeys.o  -ldl  
make[3]: Leaving directory `/home/julien/src/xsf/git/lib/libx11/obj-i486-linux-gnu/src/util'
../src/util/makekeys < /usr/include/X11/keysymdef.h > ks_tables_h
mv ks_tables_h ks_tables.h
/usr/bin/make  all-recursive
make[3]: Entering directory `/home/julien/src/xsf/git/lib/libx11/obj-i486-linux-gnu/src'
Making all in util
make[4]: Entering directory `/home/julien/src/xsf/git/lib/libx11/obj-i486-linux-gnu/src/util'
make[4]: Nothing to be done for `all'.
make[4]: Leaving directory `/home/julien/src/xsf/git/lib/libx11/obj-i486-linux-gnu/src/util'

Cheers,
Julien



Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#425445; Package libx11. Full text and rfc822 format available.

Acknowledgement sent to Neil Williams <codehelp@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #49 received at 425445@bugs.debian.org (full text, mbox):

From: Neil Williams <codehelp@debian.org>
To: Julien Cristau <jcristau@debian.org>, 425445@bugs.debian.org
Subject: Re: Bug#425445: libx11-6: fails to cross-build. tries to run cross-built makekeys utility
Date: Mon, 13 Aug 2007 00:08:58 +0100
[Message part 1 (text/plain, inline)]
On Sun, 12 Aug 2007 23:21:05 +0100
Neil Williams <codehelp@debian.org> wrote:

> (Gee, another 6 dependencies - that's just what I needed for an
> embedded X11 system.) :-(

Actually, can those new dependencies be removed by tweaking ./configure
during the cross-build? What do they provide in the package in
experimental that is not part of the package in unstable?

Regarding the original bug:
The only other method is a complete duplicate build - build once with:
dpkg-buildpackage -a $(DEB_BUILD_GNU_TYPE)
copy makekeys (or makekeys output) into the new tree
dpkg-buildpackage -a $(DEB_HOST_GNU_TYPE)

This would then involve creating new targets in debian/rules that make
this duplicate build as small as possible (matching how OpenEmbedded
build packages like these).

I hope you can see that this is also a Debian-only fix.

I have not been able to make either of your suggestions actually work
without using 'override' and I currently cannot see any way of creating
a sane patch suitable for upstream - barring generating the output of
makekeys BEFORE release and incorporating it into the actual release.
(i.e. a duplicate build where the first part of the build is actually
done prior to release and is never done again for the life of
the .orig.tar.gz). OK, it makes the released tarball larger but
certainly for Emdebian, that is inconsequential - we care about the
size of the cross-built binaries, not the release tarball.

Is the *output* of makekeys actually architecture-dependent?

Other packages in the same situation (fontconfig), simply use utilities
like this for the sake of upstream convenience - any parser would do,
it just so happens that upstream chose a compiled language instead of
an interpreted language to convert the input of the utility (which is
presumably easier to edit) into a format suitable for inclusion
directly into the source code for compilation (which is usually hard to
edit).

I will investigate the duplicate build option ("staging") later this
week.

-- 


Neil Williams
=============
http://www.data-freedom.org/
http://www.nosoftwarepatents.com/
http://www.linux.codehelp.co.uk/

[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#425445; Package libx11. Full text and rfc822 format available.

Acknowledgement sent to Julien Cristau <jcristau@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #54 received at 425445@bugs.debian.org (full text, mbox):

From: Julien Cristau <jcristau@debian.org>
To: Neil Williams <codehelp@debian.org>
Cc: 425445@bugs.debian.org
Subject: Re: Bug#425445: libx11-6: fails to cross-build. tries to run cross-built makekeys utility
Date: Mon, 13 Aug 2007 01:15:31 +0200
On Mon, Aug 13, 2007 at 00:08:58 +0100, Neil Williams wrote:

> On Sun, 12 Aug 2007 23:21:05 +0100
> Neil Williams <codehelp@debian.org> wrote:
> 
> > (Gee, another 6 dependencies - that's just what I needed for an
> > embedded X11 system.) :-(
> 
> Actually, can those new dependencies be removed by tweaking ./configure
> during the cross-build? What do they provide in the package in
> experimental that is not part of the package in unstable?
> 
http://lists.debian.org/debian-devel-announce/2006/11/msg00010.html

> Regarding the original bug:
> The only other method is a complete duplicate build - build once with:
> dpkg-buildpackage -a $(DEB_BUILD_GNU_TYPE)
> copy makekeys (or makekeys output) into the new tree
> dpkg-buildpackage -a $(DEB_HOST_GNU_TYPE)
> 
Why the hell can't makekeys be built with a native compiler?  AIUI,
that's what CC_FOR_BUILD is supposed to be...

Cheers,
Julien



Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#425445; Package libx11. Full text and rfc822 format available.

Acknowledgement sent to Neil Williams <codehelp@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #59 received at 425445@bugs.debian.org (full text, mbox):

From: Neil Williams <codehelp@debian.org>
To: Julien Cristau <jcristau@debian.org>
Cc: 425445@bugs.debian.org, Debian Embedded <debian-embedded@lists.debian.org>
Subject: Re: Bug#425445: libx11-6: fails to cross-build. tries to run cross-built makekeys utility
Date: Mon, 13 Aug 2007 00:31:35 +0100
[Message part 1 (text/plain, inline)]
On Mon, 13 Aug 2007 00:57:04 +0200
Julien Cristau <jcristau@debian.org> wrote:

> On Sun, Aug 12, 2007 at 23:21:05 +0100, Neil Williams wrote:
> 
> > I'm not sure why you thought this would work because the debdiff
> > contained no changes that would have resulted in the src/utils/Makefile
> > using gcc in place of arm-linux-gnu-gcc because the critical variables
> > are defined BEFORE CC_FOR_BUILD is even specified. THAT is why I had to
> > use override.
> > 
> What variables?  

makekeys_LINK, LINK and COMPILE.

> src/utils/Makefile.in has 'CC = @CC_FOR_BUILD@', which
> becomes 'CC = gcc' in src/utils/Makefile.

But src/utils/Makefile does not exist.
It is obj-x86_64-linux-gnu/src/utils/Makefile
or obj-$(DEB_BUILD_GNU_TYPE)/src/utils/Makefile
(from debian/rules)

> I don't believe the only way to build makekeys with a native compiler is
> using a gnu makeism.

I only wish that such a method would actually work.
 
> > What are you using to build at your end? What is it that makes you
> > think that this can be solved without 'override' ?
> > 
> I installed the libc6-dev-arm-cross and gcc-4.1-arm-linux-gnu from the
> emdebian repo, symlinked /usr/include/X11 from
> /usr/arm-linux-gnu/include/ (hopefully any differences here don't
> matter), and ran dpkg-buildpackage -rfakeroot -B -aarm.
> Of course the package doesn't build because I don't have some of the
> necessary stuff, but it gets further than the makekeys stuff.

So you don't have dpkg-cross installed?

I think this is a completely different bug.

I use emdebuild (part of emdebian-tools) which merely does some useful
stuff to prepare patch files and then calls the dpkg-cross diversion of
dpkg-buildpackage -rfakeroot -a$ARCH etc. to do the rest of the work.

With a fully operational toolchain installed, dpkg-buildpackage fails
at makekeys just like emdebuild (which is exactly what I would expect).
 
> The log has:
> /bin/sh ../../../libtool --tag=CC   --mode=link arm-linux-gnu-gcc -I../../../../include -I../../../../include/X11 -I../../../include -I../../../include/X11 -I../../../../src/xcms -I../../../../src/xkb -I../../../../src/xlibi18n -I../../../../src -Wall -Wpointer-arith -Wstrict-prototypes         -Wmissing-prototypes -Wmissing-declarations     -Wnested-externs -fno-strict-aliasing -D_BSD_SOURCE -DHAS_FCHOWN -DHAS_STICKY_DIR_BIT          -D_BSD_SOURCE -DMALLOC_0_RETURNS_NULL -Wall -g -O2   -o libxomGeneric.la  omDefault.lo omGeneric.lo omImText.lo omText.lo omTextEsc.lo omTextExt.lo omTextPer.lo omXChar.lo  -ldl 
> arm-linux-gnu-ar cru .libs/libxomGeneric.a .libs/omDefault.o .libs/omGeneric.o .libs/omImText.o .libs/omText.o .libs/omTextEsc.o .libs/omTextExt.o .libs/omTextPer.o .libs/omXChar.o
> arm-linux-gnu-ranlib .libs/libxomGeneric.a
> creating libxomGeneric.la
> (cd .libs && rm -f libxomGeneric.la && ln -s ../libxomGeneric.la libxomGeneric.la)
> make[4]: Leaving directory `/home/julien/src/xsf/git/lib/libx11/obj-i486-linux-gnu/modules/om/generic'
> make[4]: Entering directory `/home/julien/src/xsf/git/lib/libx11/obj-i486-linux-gnu/modules/om'
> make[4]: Nothing to be done for `all-am'.
> make[4]: Leaving directory `/home/julien/src/xsf/git/lib/libx11/obj-i486-linux-gnu/modules/om'
> make[3]: Leaving directory `/home/julien/src/xsf/git/lib/libx11/obj-i486-linux-gnu/modules/om'
> make[3]: Entering directory `/home/julien/src/xsf/git/lib/libx11/obj-i486-linux-gnu/modules'
> make[3]: Nothing to be done for `all-am'.
> make[3]: Leaving directory `/home/julien/src/xsf/git/lib/libx11/obj-i486-linux-gnu/modules'
> make[2]: Leaving directory `/home/julien/src/xsf/git/lib/libx11/obj-i486-linux-gnu/modules'
> Making all in src
> make[2]: Entering directory `/home/julien/src/xsf/git/lib/libx11/obj-i486-linux-gnu/src'
> cd util && /usr/bin/make
> make[3]: Entering directory `/home/julien/src/xsf/git/lib/libx11/obj-i486-linux-gnu/src/util'
> gcc -DHAVE_CONFIG_H -I. -I../../src -I../../include/X11 -I../../../src/util    -Wall -Wpointer-arith -Wstrict-prototypes        -Wmissing-prototypes -Wmissing-declarations     -Wnested-externs -fno-strict-aliasing -D_BSD_SOURCE -DHAS_FCHOWN -DHAS_STICKY_DIR_BIT        -Wall -g -O2 -MT makekeys-makekeys.o -MD -MP -MF .deps/makekeys-makekeys.Tpo -c -o makekeys-makekeys.o `test -f 'makekeys.c' || echo '../../../src/util/'`makekeys.c

In the same position, I get:
arm-linux-gnu-gcc -DHAVE_CONFIG_H -I. -I../../src -I../../include/X11 -I../../../src/util    -Wall -Wpointer-arith -Wstrict-prototypes       -Wmissing-prototypes -Wmissing-declarations     -Wnested-externs -fno-strict-aliasing -D_BSD_SOURCE -DHAS_FCHOWN -DHAS_STICKY_DIR_BIT -I/usr/arm-linux-gnu/include    -I/usr/arm-linux-gnu/include   -I/usr/arm-linux-gnu/include   -Wall -g -O2 -MT makekeys-makekeys.o -MD -MP -MF .deps/makekeys-makekeys.Tpo -c -o makekeys-makekeys.o `test -f 'makekeys.c' || echo '../../../src/util/'`makekeys.c

Wrong compiler.
:-(

Note that the actual values of the variables are NOT taken from the
Makefile but from dpkg-buildpackage unless 'override' forces the
reverse handling, as documented in GNU make.

If I avoid the dpkg-cross diversion
(dpkg-buildpackage.orig -rfakeroot -a$ARCH etc.)
makekeys DOES compile under GCC and run.

For now, I'm cloning this bug against dpkg-cross until I can get the
dpkg-buildpackage.orig build to complete, at which point I'll let you
know exactly what patch is or is not required for this bug.

-- 


Neil Williams
=============
http://www.data-freedom.org/
http://www.nosoftwarepatents.com/
http://www.linux.codehelp.co.uk/

[Message part 2 (application/pgp-signature, inline)]

Bug 425445 cloned as bug 437507. Request was from Neil Williams <codehelp@debian.org> to control@bugs.debian.org. (Sun, 12 Aug 2007 23:36:03 GMT) Full text and rfc822 format available.

Bug reassigned from package `libx11' to `dpkg-cross'. Request was from Neil Williams <codehelp@debian.org> to control@bugs.debian.org. (Sun, 12 Aug 2007 23:36:04 GMT) Full text and rfc822 format available.

Tags removed: upstream Request was from Neil Williams <codehelp@debian.org> to control@bugs.debian.org. (Sun, 12 Aug 2007 23:42:02 GMT) Full text and rfc822 format available.

Tags removed: patch Request was from Neil Williams <codehelp@debian.org> to control@bugs.debian.org. (Sun, 12 Aug 2007 23:42:03 GMT) Full text and rfc822 format available.

Changed Bug title to `dpkg-cross: broken CC_FOR_BUILD handling in diverted dpkg-buildpackage' from `libx11-6: fails to cross-build. tries to run cross-built makekeys utility'. Request was from Neil Williams <codehelp@debian.org> to control@bugs.debian.org. (Sun, 12 Aug 2007 23:45:03 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Embedded Group <debian-embedded@lists.debian.org>:
Bug#437507; Package dpkg-cross. Full text and rfc822 format available.

Acknowledgement sent to Neil Williams <codehelp@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Embedded Group <debian-embedded@lists.debian.org>. Full text and rfc822 format available.

Message #74 received at 437507@bugs.debian.org (full text, mbox):

From: Neil Williams <codehelp@debian.org>
To: Debian Embedded <debian-embedded@lists.debian.org>
Cc: 437507@bugs.debian.org
Subject: #437507 dpkg-cross: broken CC_FOR_BUILD handling in diverted dpkg-buildpackage
Date: Tue, 14 Aug 2007 10:07:39 +0100
[Message part 1 (text/plain, inline)]
Why is the dpkg-cross diversion of dpkg-buildpackage explicitly
overriding the MAKEFLAGS environment variable?

DEBUG: setmakeflags=w -- NM=arm-linux-gnu-nm CC=arm-linux-gnu-gcc
GCC=arm-linux-gnu-gcc AR=arm-linux-gnu-ar RANLIB=arm-linux-gnu-ranlib
CONFIG_SITE=/etc/dpkg-cross/cross-config.arm AS=arm-linux-gnu-as
USRLIBDIR=/usr/arm-linux-gnu/lib LD=arm-linux-gnu-ld CXX=arm-linux-gnu-g
++ ARCH=arm CPP=arm-linux-gnu-cpp RC=windres IMAKECPP=arm-linux-gnu-cpp

$(MAKE) then receives those settings on the command line via $ENV
{'MAKEFLAGS'} and assigns those values a higher priority than whatever
is in the obj-foo/src/util/Makefile which means that CC is not set to
CC_FOR_BUILD, it is set to arm-linux-gnu-gcc, hence the failure in
libx11-6 where CC_FOR_BUILD should be set to 'gcc' so that a buildtime
target can be compiled and run. To reset this, I initially used the
'override' command to $(MAKE) but this is only supported by GNU Make.
However, using 'override' did solve the problem and that is how the
current libx11-6 package was built for Emdebian.

The current behaviour undermines this requirement:
# Prepend /usr/share/dpkg-cross/ to PATH to make use of the strip wrapper.
# Also append $crossbin, so that cross binaries can be found, but
# native stuff still has precedence (if a package wants to compile
# with 'gcc' a build tool that will be executed, for example).
(dpkg-cross.pl line 485)

The setting of MAKEFLAGS means that a package that needs to compile a
build tool with 'gcc' that will be executed, the tool actually gets
compiled with $archtriplet-gcc instead and then promptly dies.

This would also solve cross-build failures in a number of other
packages (like fontconfig) where build tools need to be compiled and
run within a cross-build.

I'm testing with simply not specifying any MAKEFLAGS or removing CC,
GCC, CXX, CPP and IMAKECPP from the %std_tools list in dpkg-cross.pl so
that MAKEFLAGS does not change CC behaviour, only AS, LD, AR, NM,
RANLIB and RC.

I'll also implement a --debug mode in the diverted dpkg-buildpackage
for future testing, outputting to a file in /tmp/.

As part of these changes, I'll also test #430507 "dpkg-cross: [Patch]
Check dpkg-architecture before falling back to internal tables" - note
the unfortunate coincidence in the bug number (!) and prepare a
dpkg-cross 1.99+2.0.0pre1 release that will go into Debian
experimental for testing.

-- 


Neil Williams
=============
http://www.data-freedom.org/
http://www.nosoftwarepatents.com/
http://www.linux.codehelp.co.uk/

[Message part 2 (application/pgp-signature, inline)]

Tags added: pending Request was from Neil Williams <codehelp@debian.org> to control@bugs.debian.org. (Tue, 14 Aug 2007 23:12:03 GMT) Full text and rfc822 format available.

Tags added: fixed-in-experimental Request was from Neil Williams <codehelp@debian.org> to control@bugs.debian.org. (Wed, 22 Aug 2007 10:27:05 GMT) Full text and rfc822 format available.

Reply sent to Neil Williams <codehelp@debian.org>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Neil Williams <codehelp@debian.org>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #83 received at 437507-close@bugs.debian.org (full text, mbox):

From: Neil Williams <codehelp@debian.org>
To: 437507-close@bugs.debian.org
Subject: Bug#437507: fixed in dpkg-cross 1.99+2.0.0pre1
Date: Tue, 28 Aug 2007 23:00:50 +0000
Source: dpkg-cross
Source-Version: 1.99+2.0.0pre1

We believe that the bug you reported is fixed in the latest version of
dpkg-cross, which is due to be installed in the Debian FTP archive:

dpkg-cross_1.99+2.0.0pre1.dsc
  to pool/main/d/dpkg-cross/dpkg-cross_1.99+2.0.0pre1.dsc
dpkg-cross_1.99+2.0.0pre1.tar.gz
  to pool/main/d/dpkg-cross/dpkg-cross_1.99+2.0.0pre1.tar.gz
dpkg-cross_1.99+2.0.0pre1_all.deb
  to pool/main/d/dpkg-cross/dpkg-cross_1.99+2.0.0pre1_all.deb
libdebian-dpkgcross-perl_1.99+2.0.0pre1_all.deb
  to pool/main/d/dpkg-cross/libdebian-dpkgcross-perl_1.99+2.0.0pre1_all.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 437507@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Neil Williams <codehelp@debian.org> (supplier of updated dpkg-cross package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.7
Date: Wed, 15 Aug 2007 07:20:26 +0100
Source: dpkg-cross
Binary: libdebian-dpkgcross-perl dpkg-cross
Architecture: source all
Version: 1.99+2.0.0pre1
Distribution: experimental
Urgency: low
Maintainer: Debian Embedded Group <debian-embedded@lists.debian.org>
Changed-By: Neil Williams <codehelp@debian.org>
Description: 
 dpkg-cross - tools for cross compiling Debian packages
 libdebian-dpkgcross-perl - functions to aid cross-compiling Debian packages
Closes: 72405 115247 284275 430507 437507
Changes: 
 dpkg-cross (1.99+2.0.0pre1) experimental; urgency=low
 .
   * refactoring for a 2.0.0 release.
   * config.common linux specific (Closes: #72405)
   * [Patch] Check dpkg-architecture before falling back to internal
     tables (Closes: #430507)
   * cross-config.common, cross-config.${arch_os} files (Closes: #284275)
   * broken CC_FOR_BUILD handling in diverted
   dpkg-buildpackage (Closes: #437507)
   * Migrate to CDBS
   * broken on anything but GNU/linux (Closes: #115247)
Files: 
 4003f80420125c96b01afa5ebbf1f377 939 utils extra dpkg-cross_1.99+2.0.0pre1.dsc
 f24e1e645db311837a854e00c0816748 76454 utils extra dpkg-cross_1.99+2.0.0pre1.tar.gz
 b74d1dd102a8a5011b01fe4595cc10eb 59224 utils extra dpkg-cross_1.99+2.0.0pre1_all.deb
 80b79a5fd4f7f9a6682f3903e4d3becd 27082 perl extra libdebian-dpkgcross-perl_1.99+2.0.0pre1_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.6 (GNU/Linux)

iD8DBQFGy3c7iAEJSii8s+MRAvHJAKCVq9vss8DypaTi92SpymdaqOSLagCgquIi
T7Jmuy5TXT1bX32zIQ7ENfk=
=SGf5
-----END PGP SIGNATURE-----




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Mon, 26 Nov 2007 07:25:42 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sun Apr 20 21:18:25 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.